Index: trunk/NEMOGCM/NEMO/OPA_SRC/IOM/iom_nf90.F90
===================================================================
--- trunk/NEMOGCM/NEMO/OPA_SRC/IOM/iom_nf90.F90	(revision 2527)
+++ trunk/NEMOGCM/NEMO/OPA_SRC/IOM/iom_nf90.F90	(revision 2528)
@@ -28,15 +28,20 @@
 
    PUBLIC iom_nf90_open, iom_nf90_close, iom_nf90_varid, iom_nf90_get, iom_nf90_gettime, iom_nf90_rstput
+   PUBLIC iom_nf90_getatt
 
    INTERFACE iom_nf90_get
       MODULE PROCEDURE iom_nf90_g0d, iom_nf90_g123d
+   END INTERFACE
+   INTERFACE iom_nf90_getatt
+      MODULE PROCEDURE iom_nf90_intatt
    END INTERFACE
    INTERFACE iom_nf90_rstput
       MODULE PROCEDURE iom_nf90_rp0123d
    END INTERFACE
+
    !!----------------------------------------------------------------------
-   !!  OPA 9.0 , LOCEAN-IPSL (2006)
+   !! NEMO/OPA 3.3 , NEMO Consortium (2010)
    !! $Id$
-   !! Software governed by the CeCILL licence (modipsl/doc/NEMO_CeCILL.txt)
+   !! Software governed by the CeCILL licence (NEMOGCM/NEMO_CeCILL.txt)
    !!----------------------------------------------------------------------
 
@@ -63,5 +68,6 @@
       INTEGER            ::   jl               ! loop variable
       INTEGER            ::   ichunk           ! temporary storage of nn_chunksz
-      INTEGER            ::   imode            ! creation mode flag: NF90_CLOBBER or NF90_NOCLOBBER
+      INTEGER            ::   imode            ! creation mode flag: NF90_CLOBBER or NF90_NOCLOBBER or NF90_HDF5
+      INTEGER            ::   ihdf5            ! local variable for retrieval of value for NF90_HDF5
       LOGICAL            ::   llclobber        ! local definition of ln_clobber
       !---------------------------------------------------------------------
@@ -78,5 +84,9 @@
          IF( ldwrt ) THEN  ! ... in write mode
             IF(lwp) WRITE(numout,*) TRIM(clinfo)//' open existing file: '//TRIM(cdname)//' in WRITE mode'
-            CALL iom_nf90_check(NF90_OPEN( TRIM(cdname), NF90_WRITE  , if90id, chunksize = ichunk ), clinfo)
+            IF( snc4set%luse ) THEN
+               CALL iom_nf90_check(NF90_OPEN( TRIM(cdname), NF90_WRITE  , if90id ), clinfo)
+            ELSE
+               CALL iom_nf90_check(NF90_OPEN( TRIM(cdname), NF90_WRITE  , if90id, chunksize = ichunk ), clinfo)
+            ENDIF
             CALL iom_nf90_check(NF90_SET_FILL( if90id, NF90_NOFILL, idmy                          ), clinfo)
          ELSE              ! ... in read mode
@@ -97,5 +107,14 @@
             ELSE                   ;   imode = IOR( NF90_64BIT_OFFSET, NF90_NOCLOBBER ) 
             ENDIF
-            CALL iom_nf90_check(NF90_CREATE( TRIM(cdname), imode, if90id, chunksize = ichunk ), clinfo)
+            IF( snc4set%luse ) THEN
+               IF(lwp) WRITE(numout,*) TRIM(clinfo)//' creating file: '//TRIM(cdname)//' in hdf5 (netcdf4) mode'
+               CALL GET_NF90_SYMBOL("NF90_HDF5", ihdf5)
+               IF( llclobber ) THEN   ;   imode = IOR(ihdf5, NF90_CLOBBER)
+               ELSE                   ;   imode = IOR(ihdf5, NF90_NOCLOBBER)
+               ENDIF
+               CALL iom_nf90_check(NF90_CREATE( TRIM(cdname), imode, if90id ), clinfo)
+            ELSE
+               CALL iom_nf90_check(NF90_CREATE( TRIM(cdname), imode, if90id, chunksize = ichunk ), clinfo)
+            ENDIF
             CALL iom_nf90_check(NF90_SET_FILL( if90id, NF90_NOFILL, idmy                     ), clinfo)
             ! define dimensions
@@ -288,4 +307,32 @@
 
 
+   SUBROUTINE iom_nf90_intatt( kiomid, cdatt, pvar )
+      !!-----------------------------------------------------------------------
+      !!                  ***  ROUTINE  iom_nf90_intatt  ***
+      !!
+      !! ** Purpose : read an integer attribute with NF90
+      !!-----------------------------------------------------------------------
+      INTEGER         , INTENT(in   ) ::   kiomid   ! Identifier of the file
+      CHARACTER(len=*), INTENT(in   ) ::   cdatt    ! attribute name
+      INTEGER         , INTENT(  out) ::   pvar     ! read field
+      !
+      INTEGER                         ::   if90id   ! temporary integer
+      LOGICAL                         ::   llok     ! temporary logical
+      CHARACTER(LEN=100)              ::   clinfo   ! info character
+      !---------------------------------------------------------------------
+      ! 
+      if90id = iom_file(kiomid)%nfid
+      llok = NF90_Inquire_attribute(if90id, NF90_GLOBAL, cdatt) == nf90_noerr
+      IF( llok) THEN
+         clinfo = 'iom_nf90_getatt, file: '//TRIM(iom_file(kiomid)%name)//', att: '//TRIM(cdatt)
+         CALL iom_nf90_check(NF90_GET_ATT(if90id, NF90_GLOBAL, cdatt, values=pvar), clinfo)
+      ELSE
+         CALL ctl_warn('iom_nf90_getatt: no attribute '//cdatt//' found')
+         pvar = -999
+      ENDIF
+      ! 
+   END SUBROUTINE iom_nf90_intatt
+
+
    SUBROUTINE iom_nf90_gettime( kiomid, kvid, ptime, cdunits, cdcalendar )
       !!--------------------------------------------------------------------
@@ -346,4 +393,11 @@
       INTEGER               :: idmy                 ! dummy variable
       INTEGER               :: itype                ! variable type
+      INTEGER, DIMENSION(4) :: ichunksz             ! NetCDF4 chunk sizes. Will be computed using
+                                                    ! nn_nchunks_[i,j,k,t] namelist parameters
+      INTEGER               :: ichunkalg, ishuffle,&
+                               ideflate, ideflate_level
+                                                    ! NetCDF4 internally fixed parameters
+      LOGICAL               :: lchunk               ! logical switch to activate chunking and compression
+                                                    ! when appropriate (currently chunking is applied to 4d fields only)
       !---------------------------------------------------------------------
       !
@@ -376,4 +430,11 @@
       ! ===============
       IF( kvid <= 0 ) THEN
+         !
+         ! NetCDF4 chunking and compression fixed settings
+         ichunkalg = 0
+         ishuffle = 1
+         ideflate = 1
+         ideflate_level = 1
+         !
          idvar = iom_file(kiomid)%nvars + 1
          ! are we in define mode?
@@ -406,4 +467,6 @@
                  &                            iom_file(kiomid)%nvid(idvar) ), clinfo)
          ENDIF
+         lchunk = .false.
+         IF( snc4set%luse .AND. idims.eq.4 ) lchunk = .true.
          ! update informations structure related the new variable we want to add...
          iom_file(kiomid)%nvars         = idvar
@@ -417,5 +480,18 @@
          DO jd = 1, idims
             CALL iom_nf90_check(NF90_INQUIRE_DIMENSION( if90id, idimid(jd), len = iom_file(kiomid)%dimsz(jd,idvar) ), clinfo)
+            IF ( lchunk ) ichunksz(jd) = iom_file(kiomid)%dimsz(jd,idvar)
          END DO
+         IF ( lchunk ) THEN
+            ! Calculate chunk sizes by partitioning each dimension as requested in namnc4 namelist
+            ! Disallow very small chunk sizes and prevent chunk sizes larger than each individual dimension
+            ichunksz(1) = MIN( ichunksz(1),MAX( (ichunksz(1)-1)/snc4set%ni + 1 ,16 ) ) ! Suggested default nc4set%ni=4
+            ichunksz(2) = MIN( ichunksz(2),MAX( (ichunksz(2)-1)/snc4set%nj + 1 ,16 ) ) ! Suggested default nc4set%nj=2
+            ichunksz(3) = MIN( ichunksz(3),MAX( (ichunksz(3)-1)/snc4set%nk + 1 , 1 ) ) ! Suggested default nc4set%nk=6
+            ichunksz(4) = 1                                                            ! Do not allow chunks to span the
+                                                                                       ! unlimited dimension
+            CALL iom_nf90_check(SET_NF90_DEF_VAR_CHUNKING(if90id, idvar, ichunkalg, ichunksz), clinfo)
+            CALL iom_nf90_check(SET_NF90_DEF_VAR_DEFLATE(if90id, idvar, ishuffle, ideflate, ideflate_level), clinfo)
+            IF(lwp) WRITE(numout,*) TRIM(clinfo)//' chunked ok. Chunks sizes: ', ichunksz
+         ENDIF
          IF(lwp) WRITE(numout,*) TRIM(clinfo)//' defined ok'
       ELSE
@@ -497,5 +573,4 @@
    END SUBROUTINE iom_nf90_check
 
-
    !!======================================================================
 END MODULE iom_nf90
Index: trunk/NEMOGCM/NEMO/OPA_SRC/IOM/iom_rstdimg.F90
===================================================================
--- trunk/NEMOGCM/NEMO/OPA_SRC/IOM/iom_rstdimg.F90	(revision 2527)
+++ trunk/NEMOGCM/NEMO/OPA_SRC/IOM/iom_rstdimg.F90	(revision 2528)
@@ -35,7 +35,7 @@
       
    !!----------------------------------------------------------------------
-   !!  OPA 9.0 , LOCEAN-IPSL (2006)
+   !! NEMO/OPA 3.3 , NEMO Consortium (2010)
    !! $Id$
-   !! Software governed by the CeCILL licence (modipsl/doc/NEMO_CeCILL.txt)
+   !! Software governed by the CeCILL licence (NEMOGCM/NEMO_CeCILL.txt)
    !!----------------------------------------------------------------------
 
Index: trunk/NEMOGCM/NEMO/OPA_SRC/IOM/prtctl.F90
===================================================================
--- trunk/NEMOGCM/NEMO/OPA_SRC/IOM/prtctl.F90	(revision 2527)
+++ trunk/NEMOGCM/NEMO/OPA_SRC/IOM/prtctl.F90	(revision 2528)
@@ -31,7 +31,7 @@
    PUBLIC prt_ctl_init    ! called by opa.F90
    !!----------------------------------------------------------------------
-   !!   OPA 9.0 , LOCEAN-IPSL (2005) 
+   !! NEMO/OPA 3.3 , NEMO Consortium (2010)
    !! $Id$ 
-   !! This software is governed by the CeCILL licence see modipsl/doc/NEMO_CeCILL.txt 
+   !! Software governed by the CeCILL licence (NEMOGCM/NEMO_CeCILL.txt)
    !!----------------------------------------------------------------------
 
Index: trunk/NEMOGCM/NEMO/OPA_SRC/IOM/restart.F90
===================================================================
--- trunk/NEMOGCM/NEMO/OPA_SRC/IOM/restart.F90	(revision 2527)
+++ trunk/NEMOGCM/NEMO/OPA_SRC/IOM/restart.F90	(revision 2528)
@@ -4,8 +4,9 @@
    !! Ocean restart :  write the ocean restart file
    !!======================================================================
-   !! History :        !  99-11  (M. Imbard)  Original code
-   !!             8.5  !  02-08  (G. Madec)  F90: Free form
-   !!             9.0  !  05-11  (V. Garnier) Surface pressure gradient organization
-   !!             9.0  !  06-07  (S. Masson)  use IOM for restart
+   !! History :  OPA  !  1999-11  (M. Imbard)  Original code
+   !!   NEMO     1.0  !  2002-08  (G. Madec)  F90: Free form
+   !!            2.0  !  2006-07  (S. Masson)  use IOM for restart
+   !!            3.3  !  2010-04  (M. Leclair, G. Madec)  modified LF-RA
+   !!            - -  !  2010-10  (C. Ethe, G. Madec) TRC-TRA merge (T-S in 4D)
    !!----------------------------------------------------------------------
 
@@ -15,15 +16,13 @@
    !!   rst_read   : read the ocean restart file
    !!----------------------------------------------------------------------
+   USE oce             ! ocean dynamics and tracers 
    USE dom_oce         ! ocean space and time domain
-   USE oce             ! ocean dynamics and tracers 
    USE phycst          ! physical constants
    USE in_out_manager  ! I/O manager
    USE iom             ! I/O module
-   USE c1d             ! re-initialization of u-v mask for the 1D configuration
-   USE zpshde          ! partial step: hor. derivative (zps_hde routine)
    USE eosbn2          ! equation of state            (eos bn2 routine)
-   USE zdfddm          ! double diffusion mixing 
-   USE zdfmxl          ! mixed layer depth
    USE trdmld_oce      ! ocean active mixed layer tracers trends variables
+   USE domvvl          ! variable volume
+   USE traswp          ! swap from 4D T-S to 3D T & S and vice versa
 
    IMPLICIT NONE
@@ -34,15 +33,15 @@
    PUBLIC   rst_read   ! routine called by opa  module
 
-   LOGICAL, PUBLIC ::   lrst_oce =  .FALSE.       !: logical to control the oce restart write 
-   INTEGER, PUBLIC ::   numror, numrow            !: logical unit for cean restart (read and write)
+   LOGICAL, PUBLIC ::   lrst_oce =  .FALSE.   !: logical to control the oce restart write 
+   INTEGER, PUBLIC ::   numror, numrow        !: logical unit for cean restart (read and write)
 
    !! * Substitutions
+#  include "domzgr_substitute.h90"
 #  include "vectopt_loop_substitute.h90"
    !!----------------------------------------------------------------------
-   !!  OPA 9.0 , LOCEAN-IPSL (2006) 
+   !! NEMO/OPA 3.3 , NEMO Consortium (2010)
    !! $Id$
-   !! Software governed by the CeCILL licence (modipsl/doc/NEMO_CeCILL.txt)
-   !!----------------------------------------------------------------------
-
+   !! Software governed by the CeCILL licence     (NEMOGCM/NEMO_CeCILL.txt)
+   !!----------------------------------------------------------------------
 CONTAINS
 
@@ -88,9 +87,10 @@
             CASE DEFAULT         ;   WRITE(numout,*) '             open ocean restart NetCDF file: '//clname
             END SELECT
+            IF ( snc4set%luse )      WRITE(numout,*) '             opened for NetCDF4 chunking and compression'
             IF( kt == nitrst - 1 ) THEN   ;   WRITE(numout,*) '             kt = nitrst - 1 = ', kt
             ELSE                          ;   WRITE(numout,*) '             kt = '             , kt
             ENDIF
          ENDIF
-
+         !
          CALL iom_open( clname, numrow, ldwrt = .TRUE., kiolib = jprstlib )
          lrst_oce = .TRUE.
@@ -107,33 +107,32 @@
       !!
       !! ** Method  :   Write in numrow when kt == nitrst in NetCDF
-      !!      file, save fields which are necessary for restart
+      !!              file, save fields which are necessary for restart
       !!----------------------------------------------------------------------
       INTEGER, INTENT(in) ::   kt   ! ocean time-step
       !!----------------------------------------------------------------------
 
-      CALL iom_rstput( kt, nitrst, numrow, 'rdt'    , rdt       )   ! dynamics time step
-      CALL iom_rstput( kt, nitrst, numrow, 'rdttra1', rdttra(1) )   ! surface tracer time step
-
-      CALL iom_rstput( kt, nitrst, numrow, 'ub'     , ub      )     ! before fields
-      CALL iom_rstput( kt, nitrst, numrow, 'vb'     , vb      )
-      CALL iom_rstput( kt, nitrst, numrow, 'tb'     , tb      )
-      CALL iom_rstput( kt, nitrst, numrow, 'sb'     , sb      )
-      CALL iom_rstput( kt, nitrst, numrow, 'rotb'   , rotb    )
-      CALL iom_rstput( kt, nitrst, numrow, 'hdivb'  , hdivb   )
-      CALL iom_rstput( kt, nitrst, numrow, 'sshb'   , sshb    )
-      !
-      CALL iom_rstput( kt, nitrst, numrow, 'un'     , un      )     ! now fields
-      CALL iom_rstput( kt, nitrst, numrow, 'vn'     , vn      )
-      CALL iom_rstput( kt, nitrst, numrow, 'tn'     , tn      )
-      CALL iom_rstput( kt, nitrst, numrow, 'sn'     , sn      )
-      CALL iom_rstput( kt, nitrst, numrow, 'rotn'   , rotn    )
-      CALL iom_rstput( kt, nitrst, numrow, 'hdivn'  , hdivn   )
-      CALL iom_rstput( kt, nitrst, numrow, 'sshn'   , sshn    )
-
-      CALL iom_rstput( kt, nitrst, numrow, 'rhop'   , rhop    )
+                     CALL iom_rstput( kt, nitrst, numrow, 'rdt'    , rdt       )   ! dynamics time step
+                     CALL iom_rstput( kt, nitrst, numrow, 'rdttra1', rdttra(1) )   ! surface tracer time step
+
+                     CALL iom_rstput( kt, nitrst, numrow, 'ub'     , ub        )     ! before fields
+                     CALL iom_rstput( kt, nitrst, numrow, 'vb'     , vb        )
+                     CALL iom_rstput( kt, nitrst, numrow, 'tb'     , tb        )
+                     CALL iom_rstput( kt, nitrst, numrow, 'sb'     , sb        )
+                     CALL iom_rstput( kt, nitrst, numrow, 'rotb'   , rotb      )
+                     CALL iom_rstput( kt, nitrst, numrow, 'hdivb'  , hdivb     )
+                     CALL iom_rstput( kt, nitrst, numrow, 'sshb'   , sshb      )
+      IF( lk_vvl )   CALL iom_rstput( kt, nitrst, numrow, 'fse3t_b', fse3t_b(:,:,:) )
+                     !
+                     CALL iom_rstput( kt, nitrst, numrow, 'un'     , un        )     ! now fields
+                     CALL iom_rstput( kt, nitrst, numrow, 'vn'     , vn        )
+                     CALL iom_rstput( kt, nitrst, numrow, 'tn'     , tn        )
+                     CALL iom_rstput( kt, nitrst, numrow, 'sn'     , sn        )
+                     CALL iom_rstput( kt, nitrst, numrow, 'rotn'   , rotn      )
+                     CALL iom_rstput( kt, nitrst, numrow, 'hdivn'  , hdivn     )
+                     CALL iom_rstput( kt, nitrst, numrow, 'sshn'   , sshn      )
+                     CALL iom_rstput( kt, nitrst, numrow, 'rhop'   , rhop      )
 #if defined key_zdfkpp
-      CALL iom_rstput( kt, nitrst, numrow, 'rhd'  , rhd   )
+                     CALL iom_rstput( kt, nitrst, numrow, 'rhd'    , rhd       )
 #endif
-
       IF( kt == nitrst ) THEN
          CALL iom_close( numrow )     ! close the restart file (only at last time step)
@@ -153,5 +152,5 @@
       !!----------------------------------------------------------------------
       REAL(wp) ::   zrdt, zrdttra1
-      INTEGER  ::   jlibalt = jprstlib
+      INTEGER  ::   jk, jlibalt = jprstlib
       LOGICAL  ::   llok
       !!----------------------------------------------------------------------
@@ -163,4 +162,5 @@
          CASE ( jprstdimg )   ;   WRITE(numout,*) 'rst_read : read oce binary restart file'
          END SELECT
+         IF ( snc4set%luse )      WRITE(numout,*) 'rst_read : configured with NetCDF4 support'
          WRITE(numout,*) '~~~~~~~~'
       ENDIF
@@ -184,29 +184,30 @@
       ENDIF
       ! 
-      CALL iom_get( numror, jpdom_autoglo, 'ub'   , ub    )        ! before fields
-      CALL iom_get( numror, jpdom_autoglo, 'vb'   , vb    )
-      CALL iom_get( numror, jpdom_autoglo, 'tb'   , tb    )
-      CALL iom_get( numror, jpdom_autoglo, 'sb'   , sb    )
-      CALL iom_get( numror, jpdom_autoglo, 'rotb' , rotb  )
-      CALL iom_get( numror, jpdom_autoglo, 'hdivb', hdivb )
-      CALL iom_get( numror, jpdom_autoglo, 'sshb' , sshb  )
-      !
-      CALL iom_get( numror, jpdom_autoglo, 'un'   , un    )        ! now    fields
-      CALL iom_get( numror, jpdom_autoglo, 'vn'   , vn    )
-      CALL iom_get( numror, jpdom_autoglo, 'tn'   , tn    )
-      CALL iom_get( numror, jpdom_autoglo, 'sn'   , sn    )
-      CALL iom_get( numror, jpdom_autoglo, 'rotn' , rotn  )
-      CALL iom_get( numror, jpdom_autoglo, 'hdivn', hdivn )
-      CALL iom_get( numror, jpdom_autoglo, 'sshn' , sshn  )
-
-      CALL iom_get( numror, jpdom_autoglo, 'rhop' , rhop  )        ! now    potential density
+                     CALL iom_get( numror, jpdom_autoglo, 'ub'     , ub      )   ! before fields
+                     CALL iom_get( numror, jpdom_autoglo, 'vb'     , vb      )
+                     CALL iom_get( numror, jpdom_autoglo, 'tb'     , tb      )
+                     CALL iom_get( numror, jpdom_autoglo, 'sb'     , sb      )
+                     CALL iom_get( numror, jpdom_autoglo, 'rotb'   , rotb    )
+                     CALL iom_get( numror, jpdom_autoglo, 'hdivb'  , hdivb   )
+                     CALL iom_get( numror, jpdom_autoglo, 'sshb'   , sshb    )
+      IF( lk_vvl )   CALL iom_get( numror, jpdom_autoglo, 'fse3t_b', fse3t_b(:,:,:) )
+                     !
+                     CALL iom_get( numror, jpdom_autoglo, 'un'     , un      )   ! now    fields
+                     CALL iom_get( numror, jpdom_autoglo, 'vn'     , vn      )
+                     CALL iom_get( numror, jpdom_autoglo, 'tn'     , tn      )
+                     CALL iom_get( numror, jpdom_autoglo, 'sn'     , sn      )
+                     CALL iom_get( numror, jpdom_autoglo, 'rotn'   , rotn    )
+                     CALL iom_get( numror, jpdom_autoglo, 'hdivn'  , hdivn   )
+                     CALL iom_get( numror, jpdom_autoglo, 'sshn'   , sshn    )
+                     CALL iom_get( numror, jpdom_autoglo, 'rhop'   , rhop    )   ! now    potential density
 #if defined key_zdfkpp
       IF( iom_varid( numror, 'rhd', ldstop = .FALSE. ) > 0 ) THEN
-         CALL iom_get( numror, jpdom_autoglo, 'rhd' , rhd  )       ! now    in situ density anomaly
+                     CALL iom_get( numror, jpdom_autoglo, 'rhd'    , rhd     )   ! now    in situ density anomaly
       ELSE
-         CALL eos( tn, sn, rhd )   ! compute rhd
+                     CALL tra_swap
+                     CALL eos( tsn, rhd )   ! compute rhd
       ENDIF
 #endif
-
+      !
       IF( neuler == 0 ) THEN                                  ! Euler restart (neuler=0)
          tb   (:,:,:) = tn   (:,:,:)                             ! all before fields set to now values
@@ -217,4 +218,9 @@
          hdivb(:,:,:) = hdivn(:,:,:)
          sshb (:,:)   = sshn (:,:)
+         IF( lk_vvl ) THEN
+            DO jk = 1, jpk
+               fse3t_b(:,:,jk) = fse3t_n(:,:,jk)
+            END DO
+         ENDIF
       ENDIF
       !
